/************************************************************************************
managementofareamapirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

#ifndef MANAGEMENTOFAREAMAP_H
#define MANAGEMENTOFAREAMAP_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>


//-- [ヘッダファイル] --------------------------------------------------------------------------//
#include "map.h"											// mapヘッダファイル読み込み
//----------------------------------------------------------------------------------------------//


//-- [置換] ------------------------------------------------------------------------------------//
#define WAITTIME	1000000										// 起動待ち時間 [us]
#define DEBUG_CONFIGURATION										// DEBUG定義 [デバッグ用]
#define DEBUG_INPORT											// DEBUG定義 [デバッグ用]
#define DEBUG_RHEADERFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_CATEGORYFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_COLORTABLEFILENAME									// DEBUG定義 [デバッグ用]
#define DEBUG_BMPFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_RHEADERDATA										// DEBUG定義 [デバッグ用]
#define DEBUG_CATEGORYDATA										// DEBUG定義 [デバッグ用]
#define DEBUG_COLORTABLEDATA										// DEBUG定義 [デバッグ用]
#define DEBUG_BMPDATA											// DEBUG定義 [デバッグ用]
#define DEBUG_RECV											// DEBUG定義 [デバッグ用]
#define DEBUG_VHEADERFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_ARCFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_NODEFILENAME										// DEBUG定義 [デバッグ用]
#define DEBUG_VHEADERDATA										// DEBUG定義 [デバッグ用]
#define DEBUG_ARCDATA											// DEBUG定義 [デバッグ用]
#define DEBUG_NODEDATA											// DEBUG定義 [デバッグ用]
#define DEBUG_ARCNODEDATA										// DEBUG定義 [デバッグ用]
//----------------------------------------------------------------------------------------------//


// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">
#include "intellirobotStub.h"

// </rtc-template>

using namespace RTC;

class ManagementOfAreaMap
  : public RTC::DataFlowComponentBase
{
 public:
  ManagementOfAreaMap(RTC::Manager* manager);
  ~ManagementOfAreaMap();

	// The initialize action (on CREATED->ALIVE transition)
	// formaer rtc_init_entry()
	virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  // virtual RTC::ReturnCode_t onFinalize();

  // The startup action when ExecutionContext startup
  // former rtc_starting_entry()
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  // The shutdown action when ExecutionContext stop
  // former rtc_stopping_entry()
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

	// The activated action (Active state entry action)
	// former rtc_active_entry()
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

	// The deactivated action (Active state exit action)
	// former rtc_active_exit()
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

	// The execution action that is invoked periodically
	// former rtc_active_do()
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  // The aborting action when main logic error occurred.
  // former rtc_aborting_entry()
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  // The error action in ERROR state
  // former rtc_error_do()
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  // The reset action that is invoked resetting
  // This is same but different the former rtc_init_entry()
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);

  // The state update action that is invoked after onExecute() action
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  // The action that is invoked when execution context's rate is changed
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // Configuration variable declaration
  // <rtc-template block="config_declare">
  std::string m_01_robotmapaddress;
  std::string m_02_gui;
  std::string m_03_guiaddress;
  std::string m_04_ip;
  std::string m_05_sendport;
  std::string m_06_receiveport;
  
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  TimedMapOrder m_MapOrder;
  InPort<TimedMapOrder> m_MapOrderIn;
  
  // </rtc-template>

  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  TimedMapData m_MapData;
  OutPort<TimedMapData> m_MapDataOut;
  TimedArcNode m_ArcNode;
  OutPort<TimedArcNode> m_ArcNodeOut;
  TimedLandmark m_Landmark;
  OutPort<TimedLandmark> m_LandmarkOut;


  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

	private:
 		int dummy;


		//-- [変数宣言] ----------------------------------------------------------------//

		// プログラム処理
		unsigned long i;									// カウンタ格納変数
		unsigned long j;									// カウンタ格納変数
		unsigned long k;									// カウンタ格納変数

		// 入力ポート
		unsigned long sec;									// タイムスタンプ格納変数 [sec]
		unsigned long nsec;									// タイムスタンプ格納変数 [nsec]
		unsigned short trigger;									// 動画トリガー格納変数
		unsigned short mode;									// アクセスモード格納変数
		char location[DATASIZE];								// 地域名格納配列
		char mapset[DATASIZE];									// 利用者マップセット名格納配列
		char type[DATASIZE];									// データタイプ格納配列
		long origin_x;										// 対象原点x座標格納変数 [mm]
		long origin_y;										// 対象原点y座標格納変数 [mm]
		unsigned long size_x;									// 対象範囲x座標格納変数 [mm]
		unsigned long size_y;									// 対象範囲y座標格納変数 [mm]

		// 地図管理プログラム
		int trigger_flag;									// 動作トリガーフラグ格納変数
		int gui_flag;										// GUI動作フラグ格納変数
		int r_data;										// カラーデータ格納変数 [RED]
		int g_data;										// カラーデータ格納変数 [GREEN]
		int b_data;										// カラーデータ格納変数 [BLUE]
		long map_origin_x;									// 地図原点格納変数 [x座標:mm]
		long map_origin_y;									// 地図原点格納変数 [y座標:mm]
		unsigned long cat_num;									// カテゴリファイル行数格納変数
		unsigned long col_num;									// カラーテーブルファイル行数格納変数
		unsigned long map_size_x;								// pixelサイズ格納変数 [x座標:mm]
		unsigned long map_size_y;								// pixelサイズ格納変数 [y座標:mm]
		unsigned long num_data;									// カテゴリ番号格納変数
		unsigned long min_i;									// 開始番号格納変数 [y座標]
		unsigned long min_j;									// 開始番号格納変数 [x座標]
		unsigned long max_i;									// 終了番号格納変数 [y座標]
		unsigned long max_j;									// 終了番号格納変数 [x座標]
		unsigned long map_num;									// 地図情報番号格納変数
		char gui[4];										// GUI動作格納配列
		char robotmap_addr[DATASIZE];								// robotマップアドレス格納配列
		char filename[DATASIZE];								// ファイル名格納配列
		char ch;										// 処理用文字格納変数
		char chline[2 * DATASIZE];								// 処理用行格納配列
		char map_data[DATASIZE];								// 処理用文字列格納配列
		char label[DATASIZE];									// ラベル格納配列
		char explanation[DATASIZE];								// 地図説明格納配列
		char category[DATASIZE];								// カテゴリ格納配列
		FILE *fd;										// ファイルディスクリプタ格納変数
		Picture *ppic;										// 画像データ格納構造体ポインタ
		Category *pcat;										// カテゴリデータ格納構造体ポインタ

		unsigned long arc_size;									// アークデータ数格納変数
		unsigned long node_size;								// ノードデータ数格納変数
		unsigned long arc_num;									// アークサイズ格納変数
		unsigned long node_num;									// アークサイズ格納変数
		unsigned long id;									// ノードID格納変数
		long *px;										// x座標格納変数ポインタ
		long *py;										// y座標格納変数ポインタ
		long *pr;										// 半径格納変数ポインタ
		long *px2;										// x座標格納変数ポインタ
		long *py2;										// y座標格納変数ポインタ
		long *pr2;										// 半径格納変数ポインタ
		double *ptheta;										// 方向格納変数ポインタ
		char *pexplanation;									// 説明格納配列ポインタ
		int *parc;										// アーク判断格納変数ポインタ
		unsigned long *pstartid;								// 接続開始ノード格納変数ポインタ
		unsigned long *pendid;									// 接続終了ノード格納変数ポインタ
		double *pcost;										// コスト格納変数ポインタ
		int *pnode;										// ノード格納変数ポインタ

		// GUIプログラム
		char gui_addr[DATASIZE];								// GUIプログラムアドレス格納配列
		char ip[16];										// IPアドレス格納配列
		char send_port[6];									// 送信ポート番号格納配列
		char recv_port[6];									// 受信ポート番号格納配列
		char command[DATASIZE];									// コマンドライン引数格納配列

		// UDP通信
		char send_data[BUFSIZE];								// 送信データ格納配列
		char recv_data[BUFSIZE];								// 受信データ格納配列
		int send_sock;										// ソケットディスクリプタ格納変数
		int recv_sock;										// ソケットディスクリプタ格納変数
		int recv_len;										// 受信サイズ格納変数
		struct sockaddr_in send_addr;								// アドレス格納構造体
		struct sockaddr_in recv_addr;								// アドレス格納構造体
		struct sigaction saio;									// シグナル受信時動作設定格納構造体
		socklen_t addr_size;									// アドレス格納構造体サイズ格納変数

		//------------------------------------------------------------------------------//


};


extern "C"
{
  void ManagementOfAreaMapInit(RTC::Manager* manager);
};

#endif // MANAGEMENTOFAREAMAP_H
